Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.Designer.cs	(revision 15535)
@@ -563,54 +412,9 @@
       // 
       this.lblPreviewRowsInfo.AutoSize = true;
-      this.lblPreviewRowsInfo.Location = new System.Drawing.Point(4, 4);
-      this.lblPreviewRowsInfo.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
+      this.lblPreviewRowsInfo.Location = new System.Drawing.Point(3, 3);
       this.lblPreviewRowsInfo.Name = "lblPreviewRowsInfo";
-      this.lblPreviewRowsInfo.Size = new System.Drawing.Size(400, 17);
+      this.lblPreviewRowsInfo.Size = new System.Drawing.Size(301, 13);
       this.lblPreviewRowsInfo.TabIndex = 2;
       this.lblPreviewRowsInfo.Text = "{0} rows with more than {1} % missing values would be deleted";
-      // 
-      // tabPreviewReplaceMissingValues
-      // 
-      this.tabPreviewReplaceMissingValues.Controls.Add(this.lblPreviewReplaceMissingValues);
-      this.tabPreviewReplaceMissingValues.Location = new System.Drawing.Point(4, 22);
-      this.tabPreviewReplaceMissingValues.Margin = new System.Windows.Forms.Padding(4, 4, 4, 4);
-      this.tabPreviewReplaceMissingValues.Name = "tabPreviewReplaceMissingValues";
-      this.tabPreviewReplaceMissingValues.Padding = new System.Windows.Forms.Padding(4, 4, 4, 4);
-      this.tabPreviewReplaceMissingValues.Size = new System.Drawing.Size(951, 181);
-      this.tabPreviewReplaceMissingValues.TabIndex = 6;
-      this.tabPreviewReplaceMissingValues.Text = "repl missing vals";
-      this.tabPreviewReplaceMissingValues.UseVisualStyleBackColor = true;
-      // 
-      // lblPreviewReplaceMissingValues
-      // 
-      this.lblPreviewReplaceMissingValues.AutoSize = true;
-      this.lblPreviewReplaceMissingValues.Location = new System.Drawing.Point(4, 4);
-      this.lblPreviewReplaceMissingValues.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
-      this.lblPreviewReplaceMissingValues.Name = "lblPreviewReplaceMissingValues";
-      this.lblPreviewReplaceMissingValues.Size = new System.Drawing.Size(449, 17);
-      this.lblPreviewReplaceMissingValues.TabIndex = 3;
-      this.lblPreviewReplaceMissingValues.Text = "{0} cells detected with missing values which would be replaced with {1}";
-      // 
-      // tabPreviewShuffle
-      // 
-      this.tabPreviewShuffle.Controls.Add(this.lblPreviewShuffle);
-      this.tabPreviewShuffle.Location = new System.Drawing.Point(4, 22);
-      this.tabPreviewShuffle.Margin = new System.Windows.Forms.Padding(4, 4, 4, 4);
-      this.tabPreviewShuffle.Name = "tabPreviewShuffle";
-      this.tabPreviewShuffle.Padding = new System.Windows.Forms.Padding(4, 4, 4, 4);
-      this.tabPreviewShuffle.Size = new System.Drawing.Size(951, 181);
-      this.tabPreviewShuffle.TabIndex = 4;
-      this.tabPreviewShuffle.Text = "shuffle";
-      this.tabPreviewShuffle.UseVisualStyleBackColor = true;
-      // 
-      // lblPreviewShuffle
-      // 
-      this.lblPreviewShuffle.AutoSize = true;
-      this.lblPreviewShuffle.Location = new System.Drawing.Point(4, 4);
-      this.lblPreviewShuffle.Margin = new System.Windows.Forms.Padding(4, 0, 4, 0);
-      this.lblPreviewShuffle.Name = "lblPreviewShuffle";
-      this.lblPreviewShuffle.Size = new System.Drawing.Size(337, 17);
-      this.lblPreviewShuffle.TabIndex = 0;
-      this.lblPreviewShuffle.Text = "Data will be shuffled randomly - preview not possible";
       // 
       // label9
@@ -621,27 +425,7 @@
       this.label9.TabIndex = 0;
       // 
-      // panel1
-      // 
-      this.panel1.AutoScroll = true;
-      this.panel1.Controls.Add(this.lblPreviewColumnsInfo);
-      this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel1.Location = new System.Drawing.Point(4, 4);
-      this.panel1.Name = "panel1";
-      this.panel1.Size = new System.Drawing.Size(943, 173);
-      this.panel1.TabIndex = 2;
-      // 
-      // panel2
-      // 
-      this.panel2.AutoScroll = true;
-      this.panel2.Controls.Add(this.lblPreviewColumnsVariance);
-      this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.panel2.Location = new System.Drawing.Point(4, 4);
-      this.panel2.Name = "panel2";
-      this.panel2.Size = new System.Drawing.Size(943, 173);
-      this.panel2.TabIndex = 3;
-      // 
       // ManipulationView
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(8F, 16F);
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.btnApply);
@@ -649,7 +433,6 @@
       this.Controls.Add(this.grpBoxData);
       this.Controls.Add(this.lstMethods);
-      this.Margin = new System.Windows.Forms.Padding(4, 4, 4, 4);
       this.Name = "ManipulationView";
-      this.Size = new System.Drawing.Size(985, 651);
+      this.Size = new System.Drawing.Size(739, 529);
       this.grpBoxData.ResumeLayout(false);
       this.tabsData.ResumeLayout(false);
@@ -662,8 +445,4 @@
       this.tabDataDeleteRowsInfo.ResumeLayout(false);
       this.tabDataDeleteRowsInfo.PerformLayout();
-      this.tabReplaceMissingValues.ResumeLayout(false);
-      this.tabReplaceMissingValues.PerformLayout();
-      this.tabDataShuffle.ResumeLayout(false);
-      this.tabDataShuffle.PerformLayout();
       this.grpBoxPreview.ResumeLayout(false);
       this.tabsPreview.ResumeLayout(false);
@@ -671,16 +450,12 @@
       this.tabPreviewInactive.PerformLayout();
       this.tabPreviewDeleteColumnsInfo.ResumeLayout(false);
+      this.panel1.ResumeLayout(false);
+      this.panel1.PerformLayout();
       this.tabPreviewDeleteColumnsVariance.ResumeLayout(false);
       this.tabPreviewDeleteColumnsVariance.PerformLayout();
+      this.panel2.ResumeLayout(false);
+      this.panel2.PerformLayout();
       this.tabPreviewDeleteRowsInfo.ResumeLayout(false);
       this.tabPreviewDeleteRowsInfo.PerformLayout();
-      this.tabPreviewReplaceMissingValues.ResumeLayout(false);
-      this.tabPreviewReplaceMissingValues.PerformLayout();
-      this.tabPreviewShuffle.ResumeLayout(false);
-      this.tabPreviewShuffle.PerformLayout();
-      this.panel1.ResumeLayout(false);
-      this.panel1.PerformLayout();
-      this.panel2.ResumeLayout(false);
-      this.panel2.PerformLayout();
       this.ResumeLayout(false);
 
@@ -697,6 +472,4 @@
     private System.Windows.Forms.TabPage tabPreviewDeleteColumnsVariance;
     private System.Windows.Forms.TabPage tabPreviewDeleteRowsInfo;
-    private System.Windows.Forms.TabPage tabPreviewShuffle;
-    private System.Windows.Forms.Label lblPreviewShuffle;
     private System.Windows.Forms.TabPage tabPreviewInactive;
     private System.Windows.Forms.Label lblPreviewColumnsInfo;
@@ -704,6 +477,4 @@
     private System.Windows.Forms.Label lblPreviewColumnsVariance;
     private System.Windows.Forms.Label lblPreviewRowsInfo;
-    private System.Windows.Forms.TabPage tabPreviewReplaceMissingValues;
-    private System.Windows.Forms.Label lblPreviewReplaceMissingValues;
     private System.Windows.Forms.Label label9;
     private System.Windows.Forms.TabControl tabsData;
@@ -721,15 +492,5 @@
     private System.Windows.Forms.TextBox txtDeleteRowsInfo;
     private System.Windows.Forms.Label label5;
-    private System.Windows.Forms.TabPage tabReplaceMissingValues;
-    private System.Windows.Forms.TextBox txtReplaceValue;
-    private System.Windows.Forms.ComboBox cmbReplaceWith;
-    private System.Windows.Forms.Label lblValueColon;
-    private System.Windows.Forms.Label label10;
-    private System.Windows.Forms.TabPage tabDataShuffle;
-    private System.Windows.Forms.Label lblShuffleProperties;
-    private System.Windows.Forms.ComboBox cmbVariableNames;
-    private System.Windows.Forms.Label label8;
     private System.Windows.Forms.Label lblPreviewInActive;
-    private System.Windows.Forms.CheckBox shuffleSeparatelyCheckbox;
     private System.Windows.Forms.Panel panel1;
     private System.Windows.Forms.Panel panel2;
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/ManipulationView.cs	(revision 15535)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Generic;
 using System.Drawing;
 using System.Globalization;
@@ -44,5 +43,4 @@
     public ManipulationView() {
       InitializeComponent();
-      cmbReplaceWith.SelectedIndex = 0;
       tabsData.Appearance = TabAppearance.FlatButtons;
       tabsData.ItemSize = new Size(0, 1);
@@ -56,14 +54,10 @@
         () => ValidateDeleteColumnsVariance(),
         () => ValidateDeleteRowsInfo(),
-        () => ValidateReplaceWith(),
-        () => ValidateShuffle()
       };
 
       manipulations = new Action[] {
-        () => Content.ManipulationLogic.DeleteColumnsWithMissingValuesGreater(GetDeleteColumnsInfo()),
-        () => Content.ManipulationLogic.DeleteColumnsWithVarianceSmaller(GetDeleteColumnsVariance()),
-        () => Content.ManipulationLogic.DeleteRowsWithMissingValuesGreater(GetRowsColumnsInfo()),
-        () => ReplaceMissingValues(),
-        () => Content.ManipulationLogic.Shuffle(shuffleSeparatelyCheckbox.Checked)
+        () => Content.DeleteColumnsWithMissingValuesGreater(GetDeleteColumnsInfo()),
+        () => Content.DeleteColumnsWithVarianceSmaller(GetDeleteColumnsVariance()),
+        () => Content.DeleteRowsWithMissingValuesGreater(GetRowsColumnsInfo()),
       };
     }
@@ -72,9 +66,4 @@
       base.OnContentChanged();
       if (Content != null) {
-        cmbVariableNames.Items.Clear();
-        foreach (var name in Content.ManipulationLogic.VariableNames) {
-          cmbVariableNames.Items.Add(name);
-        }
-        cmbVariableNames.SelectedIndex = 0;
         CheckFilters();
       }
@@ -83,9 +72,9 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.FilterLogic.FilterChanged += FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged += FilterLogic_FilterChanged;
     }
 
     protected override void DeregisterContentEvents() {
-      Content.FilterLogic.FilterChanged -= FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged -= FilterLogic_FilterChanged;
       base.DeregisterContentEvents();
     }
@@ -98,5 +87,5 @@
 
     private void CheckFilters() {
-      if (Content.FilterLogic.IsFiltered) {
+      if (Content.PreprocessingData.IsFiltered) {
         tabsPreview.SelectedIndex = 0;
         lstMethods.Enabled = false;
@@ -126,36 +115,10 @@
     }
 
-    private void ReplaceMissingValues() {
-      var allIndices = Content.SearchLogic.GetMissingValueIndices();
-      var columnIndex = cmbVariableNames.SelectedIndex;
-      var columnIndices = new Dictionary<int, IList<int>>{
-          {columnIndex,   allIndices[columnIndex]}
-      };
-
-      switch (cmbReplaceWith.SelectedIndex) {
-        case 0: //Value
-          Content.ManipulationLogic.ReplaceIndicesByValue(columnIndices, txtReplaceValue.Text);
-          break;
-        case 1: //Average
-          Content.ManipulationLogic.ReplaceIndicesByAverageValue(columnIndices);
-          break;
-        case 2: //Median
-          Content.ManipulationLogic.ReplaceIndicesByMedianValue(columnIndices);
-          break;
-        case 3: //Most Common
-          Content.ManipulationLogic.ReplaceIndicesByMostCommonValue(columnIndices);
-          break;
-        case 4: //Random
-          Content.ManipulationLogic.ReplaceIndicesByRandomValue(columnIndices);
-          break;
-      }
-    }
-
     private void ValidateDeleteColumnsInfo() {
       ValidateDoubleTextBox(txtDeleteColumnsInfo.Text);
       if (btnApply.Enabled) {
-        var filteredColumns = Content.ManipulationLogic.ColumnsWithMissingValuesGreater(GetDeleteColumnsInfo());
+        var filteredColumns = Content.ColumnsWithMissingValuesGreater(GetDeleteColumnsInfo());
         int count = filteredColumns.Count;
-        int columnCount = Content.FilterLogic.PreprocessingData.Columns;
+        int columnCount = Content.PreprocessingData.Columns;
         lblPreviewColumnsInfo.Text = string.Format("{0} column{1} of {2} ({3}) were detected with more than {4}% missing values.", count, (count > 1 || count == 0 ? "s" : ""), columnCount, string.Format("{0:F2}%", 100d / columnCount * count), txtDeleteColumnsInfo.Text);
 
@@ -165,7 +128,7 @@
           sb.Append(Environment.NewLine);
           sb.Append("Columns: ");
-          sb.Append(Content.SearchLogic.VariableNames.ElementAt(filteredColumns.ElementAt(0)));
+          sb.Append(Content.PreprocessingData.VariableNames.ElementAt(filteredColumns.ElementAt(0)));
           for (int i = 1; i < filteredColumns.Count; i++) {
-            string columnName = Content.SearchLogic.VariableNames.ElementAt(filteredColumns.ElementAt(i));
+            string columnName = Content.PreprocessingData.VariableNames.ElementAt(filteredColumns.ElementAt(i));
             sb.Append(", ");
             sb.Append(columnName);
@@ -186,7 +149,7 @@
       ValidateDoubleTextBox(txtDeleteColumnsVariance.Text);
       if (btnApply.Enabled) {
-        var filteredColumns = Content.ManipulationLogic.ColumnsWithVarianceSmaller(GetDeleteColumnsVariance());
+        var filteredColumns = Content.ColumnsWithVarianceSmaller(GetDeleteColumnsVariance());
         int count = filteredColumns.Count;
-        int columnCount = Content.FilterLogic.PreprocessingData.Columns;
+        int columnCount = Content.PreprocessingData.Columns;
         lblPreviewColumnsVariance.Text = string.Format("{0} column{1} of {2} ({3}) were detected with a variance smaller than {4}.", count, (count > 1 || count == 0 ? "s" : ""), columnCount, string.Format("{0:F2}%", 100d / columnCount * count), txtDeleteColumnsVariance.Text);
 
@@ -196,7 +159,7 @@
           sb.Append(Environment.NewLine);
           sb.Append("Columns: ");
-          sb.Append(Content.SearchLogic.VariableNames.ElementAt(filteredColumns.ElementAt(0)));
+          sb.Append(Content.PreprocessingData.VariableNames.ElementAt(filteredColumns.ElementAt(0)));
           for (int i = 1; i < filteredColumns.Count; i++) {
-            string columnName = Content.SearchLogic.VariableNames.ElementAt(filteredColumns.ElementAt(i));
+            string columnName = Content.PreprocessingData.VariableNames.ElementAt(filteredColumns.ElementAt(i));
             sb.Append(", ");
             sb.Append(columnName);
@@ -217,6 +180,6 @@
       ValidateDoubleTextBox(txtDeleteRowsInfo.Text);
       if (btnApply.Enabled) {
-        int count = Content.ManipulationLogic.RowsWithMissingValuesGreater(GetRowsColumnsInfo()).Count;
-        int rowCount = Content.FilterLogic.PreprocessingData.Rows;
+        int count = Content.RowsWithMissingValuesGreater(GetRowsColumnsInfo()).Count;
+        int rowCount = Content.PreprocessingData.Rows;
         lblPreviewRowsInfo.Text = count + " row" + (count > 1 || count == 0 ? "s" : "") + " of " + rowCount + " (" + string.Format("{0:F2}%", 100d / rowCount * count) + ") were detected with more than " + txtDeleteRowsInfo.Text + "% missing values.";
         if (count > 0) {
@@ -228,45 +191,4 @@
         lblPreviewRowsInfo.Text = "Preview not possible yet - please input the limit above.";
       }
-    }
-
-    private void ValidateReplaceWith() {
-      btnApply.Enabled = false;
-      string replaceWith = (string)cmbReplaceWith.SelectedItem;
-      int columnIndex = cmbVariableNames.SelectedIndex;
-
-      if (cmbReplaceWith.SelectedIndex == 0) {
-        string errorMessage;
-        string replaceValue = txtReplaceValue.Text;
-        if (string.IsNullOrEmpty(replaceValue)) {
-          lblPreviewReplaceMissingValues.Text = "Preview not possible yet - please input the text which will be used as replacement.";
-        } else if (!Content.ManipulationLogic.PreProcessingData.Validate(txtReplaceValue.Text, out errorMessage, columnIndex)) {
-          lblPreviewReplaceMissingValues.Text = "Preview not possible yet - " + errorMessage;
-        } else {
-          btnApply.Enabled = true;
-        }
-        replaceWith = "\"" + replaceValue + "\"";
-      } else {
-        btnApply.Enabled = true;
-      }
-      if (btnApply.Enabled) {
-        var allIndices = Content.SearchLogic.GetMissingValueIndices();
-        int count = allIndices[columnIndex].Count;
-        int cellCount = Content.FilterLogic.PreprocessingData.Rows * Content.FilterLogic.PreprocessingData.Columns;
-        lblPreviewReplaceMissingValues.Text = count + " cell" + (count > 1 || count == 0 ? "s" : "")
-          + " of " + cellCount + " (" + string.Format("{0:F2}%", 100d / cellCount * count) + ") were detected with missing values which would be replaced with " + replaceWith;
-        if (count > 0) {
-          lblPreviewReplaceMissingValues.Text += Environment.NewLine + Environment.NewLine + "Please press the button \"Apply Manipulation\" if you wish to perform the replacement.";
-        } else {
-          btnApply.Enabled = false;
-        }
-      }
-    }
-
-    private void ValidateShuffle() {
-      btnApply.Enabled = true;
-      lblShuffleProperties.Enabled = false;
-      lblShuffleProperties.Visible = false;
-      shuffleSeparatelyCheckbox.Enabled = true;
-      shuffleSeparatelyCheckbox.Visible = true;
     }
 
@@ -295,12 +217,4 @@
           lblPreviewRowsInfo.Text = "rows successfully deleted.";
           break;
-        case 3:
-          lblPreviewReplaceMissingValues.Text = "missing values successfully replaced.";
-          btnApply.Enabled = false;
-          break;
-        case 4:
-          lblPreviewShuffle.Text = "dataset shuffled successfully.";
-          btnApply.Enabled = false;
-          break;
       }
     }
@@ -327,15 +241,4 @@
       ValidateDeleteRowsInfo();
     }
-
-    private void cmbReplaceWith_SelectedIndexChanged(object sender, EventArgs e) {
-      bool isReplaceWithValueSelected = cmbReplaceWith.SelectedIndex == 0;
-      lblValueColon.Visible = isReplaceWithValueSelected;
-      txtReplaceValue.Visible = isReplaceWithValueSelected;
-      ValidateReplaceWith();
-    }
-
-    private void txtReplaceValue_TextChanged(object sender, EventArgs e) {
-      ValidateReplaceWith();
-    }
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15535)
@@ -87,11 +87,11 @@
 
     private void UpdateData(Dictionary<string, bool> oldVisibility = null) {
-      var logic = Content.StatisticsLogic;
-      rowsTextBox.Text = logic.GetRowCount().ToString();
-      columnsTextBox.Text = logic.GetColumnCount().ToString();
-      numericColumnsTextBox.Text = logic.GetNumericColumnCount().ToString();
-      nominalColumnsTextBox5.Text = logic.GetNominalColumnCount().ToString();
-      missingValuesTextBox.Text = logic.GetMissingValueCount().ToString();
-      totalValuesTextBox.Text = (logic.GetColumnCount() * logic.GetRowCount() - logic.GetMissingValueCount()).ToString();
+      var data = Content.PreprocessingData;
+      rowsTextBox.Text = data.Rows.ToString();
+      columnsTextBox.Text = data.Rows.ToString();
+      numericColumnsTextBox.Text = GetColumnCount<double>().ToString();
+      nominalColumnsTextBox5.Text = GetColumnCount<string>().ToString();
+      missingValuesTextBox.Text = data.GetMissingValueCount().ToString();
+      totalValuesTextBox.Text = (data.Rows * data.Rows - data.GetMissingValueCount()).ToString();
 
       var variableNames = Content.PreprocessingData.VariableNames.ToList();
@@ -107,11 +107,11 @@
         };
 
-      for (int i = 0; i < logic.GetColumnCount(); i++) {
-        var data = GetStatistics(i);
-        for (int j = 0; j < data.Count; j++) {
+      for (int i = 0; i < data.Columns; i++) {
+        var statistics = GetStatistics(i);
+        for (int j = 0; j < statistics.Count; j++) {
           if (horizontal)
-            statisticsMatrix[j, i] = data[j];
+            statisticsMatrix[j, i] = statistics[j];
           else
-            statisticsMatrix[i, j] = data[j];
+            statisticsMatrix[i, j] = statistics[j];
         }
       }
@@ -138,12 +138,22 @@
     }
 
+    public int GetColumnCount<T>() {
+      int count = 0;
+      for (int i = 0; i < Content.PreprocessingData.Columns; ++i) {
+        if (Content.PreprocessingData.VariableHasType<T>(i)) {
+          ++count;
+        }
+      }
+      return count;
+    }
+
     private List<string> GetStatistics(int varIdx) {
       List<string> list;
-      var logic = Content.StatisticsLogic;
-      if (logic.VariableHasType<double>(varIdx)) {
+      var data = Content.PreprocessingData;
+      if (data.VariableHasType<double>(varIdx)) {
         list = GetDoubleColumns(varIdx);
-      } else if (logic.VariableHasType<string>(varIdx)) {
+      } else if (data.VariableHasType<string>(varIdx)) {
         list = GetStringColumns(varIdx);
-      } else if (logic.VariableHasType<DateTime>(varIdx)) {
+      } else if (data.VariableHasType<DateTime>(varIdx)) {
         list = GetDateTimeColumns(varIdx);
       } else {
@@ -157,54 +167,54 @@
 
     private List<string> GetDoubleColumns(int statIdx) {
-      var logic = Content.StatisticsLogic;
+      var data = Content.PreprocessingData;
       return new List<string> {
-        logic.GetColumnTypeAsString(statIdx),
-        logic.GetMissingValueCount(statIdx).ToString(),
-        logic.GetMin<double>(statIdx, double.NaN).ToString(),
-        logic.GetMax<double>(statIdx, double.NaN).ToString(),
-        logic.GetMedian(statIdx).ToString(),
-        logic.GetAverage(statIdx).ToString(),
-        logic.GetStandardDeviation(statIdx).ToString(),
-        logic.GetVariance(statIdx).ToString(),
-        logic.GetOneQuarterPercentile(statIdx).ToString(),
-        logic.GetThreeQuarterPercentile(statIdx).ToString(),
-        logic.GetMostCommonValue<double>(statIdx, double.NaN).ToString(),
-        logic.GetDifferentValuesCount<double>(statIdx).ToString()
+        data.GetVariableType(statIdx).Name,
+        data.GetMissingValueCount(statIdx).ToString(),
+        data.GetMin<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetMax<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetMedian<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetMean<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetStandardDeviation<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetVariance<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetQuantile<double>(0.25, statIdx, emptyValue: double.NaN).ToString(),
+        data.GetQuantile<double>(0.75, statIdx, emptyValue: double.NaN).ToString(),
+        data.GetMode<double>(statIdx, emptyValue: double.NaN).ToString(),
+        data.GetDistinctValues<double>(statIdx).ToString()
       };
     }
 
     private List<string> GetStringColumns(int statIdx) {
-      var logic = Content.StatisticsLogic;
+      var data = Content.PreprocessingData;
       return new List<string> {
-        logic.GetColumnTypeAsString(statIdx),
-        logic.GetMissingValueCount(statIdx).ToString(),
-        "", //min
-        "", //max
-        "", //median
+        data.GetVariableType(statIdx).Name,
+        data.GetMissingValueCount(statIdx).ToString(),
+        "", // data.GetMin<string>(statIdx, emptyValue: string.Empty), //min
+        "", // data.GetMax<string>(statIdx, emptyValue: string.Empty), //max
+        "", // data.GetMedian<string>(statIdx, emptyValue: string.Empty), //median
         "", //average
         "", //standard deviation
         "", //variance
-        "", //quarter percentile
-        "", //three quarter percentile
-        logic.GetMostCommonValue<string>(statIdx,string.Empty) ?? "",
-        logic.GetDifferentValuesCount<string>(statIdx).ToString()
+        "", // data.GetQuantile<string>(0.25, statIdx, emptyValue: string.Empty), //quarter percentile
+        "", // data.GetQuantile<string>(0.75, statIdx, emptyValue: string.Empty), //three quarter percentile
+        data.GetMode<string>(statIdx, emptyValue: string.Empty),
+        data.GetDistinctValues<string>(statIdx).ToString()
       };
     }
 
     private List<string> GetDateTimeColumns(int statIdx) {
-      var logic = Content.StatisticsLogic;
+      var data = Content.PreprocessingData;
       return new List<string> {
-        logic.GetColumnTypeAsString(statIdx),
-        logic.GetMissingValueCount(statIdx).ToString(),
-        logic.GetMin<DateTime>(statIdx, DateTime.MinValue).ToString(),
-        logic.GetMax<DateTime>(statIdx, DateTime.MinValue).ToString(),
-        logic.GetMedianDateTime(statIdx).ToString(),
-        logic.GetAverageDateTime(statIdx).ToString(),
-        logic.GetStandardDeviation(statIdx).ToString(),
-        logic.GetVariance(statIdx).ToString(),
-        logic.GetOneQuarterPercentile(statIdx).ToString(),
-        logic.GetThreeQuarterPercentile(statIdx).ToString(),
-        logic.GetMostCommonValue<DateTime>(statIdx, DateTime.MinValue).ToString(),
-        logic.GetDifferentValuesCount<DateTime>(statIdx).ToString()
+        data.GetVariableType(statIdx).Name,
+        data.GetMissingValueCount(statIdx).ToString(),
+        data.GetMin<DateTime>(statIdx).ToString(),
+        data.GetMax<DateTime>(statIdx).ToString(),
+        data.GetMedian<DateTime>(statIdx).ToString(),
+        data.GetMean<DateTime>(statIdx).ToString(),
+        "", // should be of type TimeSpan //data.GetStandardDeviation<DateTime>(statIdx).ToString(),
+        "", // should be of type TimeSpan //data.GetVariance<DateTime>(statIdx).ToString(),
+        data.GetQuantile<DateTime>(0.25, statIdx).ToString(),
+        data.GetQuantile<DateTime>(0.75, statIdx).ToString(),
+        data.GetMode<DateTime>(statIdx).ToString(),
+        data.GetDistinctValues<DateTime>(statIdx).ToString()
       };
     }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/TransformationView.cs	(revision 15535)
@@ -51,9 +51,9 @@
 
     protected override void RegisterContentEvents() {
-      Content.FilterLogic.FilterChanged += FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged += FilterLogic_FilterChanged;
     }
 
     protected override void DeregisterContentEvents() {
-      Content.FilterLogic.FilterChanged -= FilterLogic_FilterChanged;
+      Content.PreprocessingData.FilterChanged -= FilterLogic_FilterChanged;
     }
 
@@ -65,5 +65,5 @@
 
     private void CheckFilters() {
-      if (Content.FilterLogic.IsFiltered) {
+      if (Content.PreprocessingData.IsFiltered) {
         applyButton.Enabled = false;
         lblFilterNotice.Visible = true;
@@ -82,5 +82,5 @@
       }
 
-      var transformator = new PreprocessingTransformator(Content.Data);
+      var transformator = new PreprocessingTransformator(Content.PreprocessingData);
       bool preserve = preserveColumnsCheckbox.CheckState == CheckState.Checked;
       string errorMsg;
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 15535)
@@ -42,18 +42,16 @@
     //Clone chart items
     protected override void itemsListView_DoubleClick(object sender, EventArgs e) {
-      if (itemsListView.SelectedItems.Count == 1) {
-        IViewShortcut item = itemsListView.SelectedItems[0].Tag as IViewShortcut;
-        if (item != null) {
-          try {
-            item = (IViewShortcut)item.Clone();
-            var view = MainFormManager.MainForm.ShowContent(item);
-            if (view != null) {
-              view.ReadOnly = ReadOnly;
-              view.Locked = Locked;
-            }
-          } catch (NullReferenceException) {
-            // cloning for preprocessing not done properly yet
-          }
+      if (itemsListView.SelectedItems.Count != 1) return;
+      IViewShortcut item = itemsListView.SelectedItems[0].Tag as IViewShortcut;
+      if (item == null) return;
+      try {
+        item = (IViewShortcut)item.Clone();
+        var view = MainFormManager.MainForm.ShowContent(item);
+        if (view != null) {
+          view.ReadOnly = ReadOnly;
+          view.Locked = Locked;
         }
+      } catch (NullReferenceException) {
+        // cloning for preprocessing not done properly yet
       }
     }
Index: /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 15534)
+++ /stable/HeuristicLab.DataPreprocessing/3.4/Content/CorrelationMatrixContent.cs	(revision 15535)
@@ -23,17 +23,18 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis;
 
 namespace HeuristicLab.DataPreprocessing {
   [Item("Feature Correlation Matrix", "Represents the feature correlation matrix.")]
-  public class CorrelationMatrixContent : Item, IViewShortcut {
+  [StorableClass]
+  public class CorrelationMatrixContent : PreprocessingContent, IViewShortcut {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Gradient; }
     }
 
+    [Storable]
     public PreprocessingContext Context { get; private set; }
-    public ITransactionalPreprocessingData PreprocessingData {
-      get { return Context.Data; }
-    }
+
 
     public DataAnalysisProblemData ProblemData {
@@ -47,5 +48,7 @@
     }
 
-    public CorrelationMatrixContent(PreprocessingContext context) {
+    #region Constructor, Cloning & Persistence
+    public CorrelationMatrixContent(PreprocessingContext context)
+      : base(context.Data) {
       Context = context;
     }
@@ -55,8 +58,12 @@
       Context = original.Context;
     }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new CorrelationMatrixContent(this, cloner);
     }
+
+    [StorableConstructor]
+    protected CorrelationMatrixContent(bool deserializing)
+      : base(deserializing) { }
+    #endregion
 
     public event DataPreprocessingChangedEventHandler Changed {
